var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "sas/dm/businessdata/controller/BusinessDataPMControllerBase", "sas/dm/businessdata/model/ObjectManagerTermWrapper", "sas/dm/businessdata/model/Term", "sas/dm/businessdata/model/TermRevision", "sas/dm/businessdata/model/TermSummary", "sas/dm/businessdata/model/WorkflowType", "sas/dm/businessdata/util/BusinessDataUtils", "sas/dm/businessdata/util/BusyKeys", "sas/dm/businessdata/util/ErrorDictionary", "sas/dm/businessdata/util/GrantedCapabilitiesCache", "sas/dm/businessdata/util/sasLineage/SASLineageUtils", "sas/dm/commons/model/ErrorResponse", "sas/dm/commons/util/Action", "sas/dm/commons/util/binding/BindableArray", "sas/dm/commons/util/binding/BindingUtils", "sas/dm/commons/util/MenuAction", "sas/dm/commons/util/SharedProperties", "sas/dm/commons/model/ValidationResponse", "sas/dm/commons/util/StringUtils", "sas/dm/commons/util/ArrayUtils", "sas/dm/commons/util/CollectionUtil"], function (require, exports, BusinessDataPMControllerBase, ObjectManagerTermWrapper, Term, TermRevision, TermSummary, WorkflowType, BusinessDataUtils, BusyKeys, ErrorDictionary, GrantedCapabilitiesCache, SASLineageUtils, ErrorResponse, Action, BindableArray, BindingUtils, MenuAction, CommonSharedProperties, ValidationResponse, StringUtils, ArrayUtils, CollectionUtil) {
    "use strict";
    var MessageDialog = sas.hc.m.MessageDialog;
    var EditTermPMController = (function (_super) {
        __extends(EditTermPMController, _super);
        function EditTermPMController() {
            var _this = _super.call(this) || this;
            _this.__settingRawTerm = false;
            _this.__currentlyHandlingOpenTermsTermChange = false;
            _this.__currentlyHandlingOpenTermsRawTermChange = false;
            _this._hasUnlockOtherUserTermsCapability = false;
            _this._isEditButtonEnabled = false;
            _this._isEditButtonVisible = false;
            _this._isRevision = false;
            _this._hasEditTermsCapabilities = false;
            _this._hasEditTermContentCapabilities = false;
            _this._hasNotifyContactsCapability = false;
            _this.duplicateTermAction = new MenuAction(_this.resources.getText("terms.createEditPage.bar.button.saveas.title"), function () { }, null, _this.resources.getText("terms.createEditPage.bar.button.saveas.title"), false, true);
            _this.workflowActionsAction = new MenuAction(_this.resources.getText("terms.viewactions.workflowactions.menuitem.label"), null, null, _this.resources.getText("terms.viewactions.workflowactions.tip.label"), true, true);
            _this.unlockTermAction = new MenuAction(_this.resources.getText("terms.viewactions.menuitem.unlock.title"), function () { }, null, _this.resources.getText("terms.viewactions.menuitem.unlock.title"), true, false, false);
            _this.renameTermAction = new MenuAction(_this.resources.getText("terms.viewactions.menuitem.rename.title"), function () { }, null, _this.resources.getText("terms.viewactions.menuitem.rename.title"), false, false);
            _this.notifyContactsTermAction = new MenuAction(_this.resources.getText("terms.viewactions.menuitem.notifyall.title"), function () { }, null, _this.resources.getText("terms.viewactions.menuitem.notifyall.title"), true, true);
            _this.savePdfTermAction = new MenuAction(_this.resources.getText("terms.viewactions.menuitem.saveaspdf.title"), function () { }, null, _this.resources.getText("terms.viewactions.menuitem.saveaspdf.title"), true, false);
            _this.refreshTermAction = new MenuAction(_this.resources.getText("terms.viewactions.menuitem.refresh.title"), function () { }, null, _this.resources.getText("terms.viewactions.menuitem.refresh.title"), true, true);
            _this.workflowActionsAction.subActions = new BindableArray();
            _this._editTermActionsMenu = new BindableArray([_this.duplicateTermAction, _this.workflowActionsAction, _this.unlockTermAction, _this.renameTermAction, _this.notifyContactsTermAction, _this.savePdfTermAction, _this.refreshTermAction]);
            return _this;
        }
        Object.defineProperty(EditTermPMController.prototype, "term", {
            get: function () {
                return this._term;
            },
            set: function (value) {
                if (!this.__currentlyHandlingOpenTermsTermChange && value) {
                    this.getMasterController().updateOpenTerm(value.id, value, null, true);
                }
                this._term = value;
                BindingUtils.unbind(this._dirtyWatcher);
                this._dirtyWatcher = BindingUtils.handlePropertyChange(this.term, "isDirty", $.proxy(this.handleIsDirtyChanged, this));
            },
            enumerable: true,
            configurable: true
        });
        EditTermPMController.prototype.handleIsDirtyChanged = function (newValue, oldValue) {
            if (newValue !== oldValue) {
                this.updateActions();
            }
        };
        EditTermPMController.prototype.handleWorkflowTaskChanged = function (newValue, oldValue) {
            if (newValue != oldValue) {
                if (this.term) {
                    if (this.rawTerm) {
                        this.term.workflowTask = this.rawTerm.workflowTask;
                    }
                    else {
                        this.term.workflowTask = null;
                    }
                }
                this.updateActions();
            }
        };
        Object.defineProperty(EditTermPMController.prototype, "rawTerm", {
            get: function () {
                return this._rawTerm;
            },
            set: function (value) {
                if (this._rawTerm == value) {
                    return;
                }
                this.__settingRawTerm = true;
                try {
                    this._rawTerm = value;
                    if (!this.__currentlyHandlingOpenTermsRawTermChange && value) {
                        this.getMasterController().updateOpenTerm(value.id, null, value, true);
                    }
                    BindingUtils.unbind(this._workflowTaskWatcher);
                    this._workflowTaskWatcher = BindingUtils.handlePropertyChange(this.rawTerm, "workflowTask", $.proxy(this.handleWorkflowTaskChanged, this), true);
                    if (this.rawTerm && this.rawTerm.workflowInstanceID && !this.rawTerm.workflowTask && !this.rawTerm.isSpecificRevision) {
                        this.getCurrentWorkflowTasks(this.rawTerm, false);
                    }
                    BindingUtils.unbind(this._rawTermEditModeWatcher);
                    this._rawTermEditModeWatcher = BindingUtils.handlePropertyChange(this.rawTerm, "isEditMode", $.proxy(this.onRawTermEditModeChanged, this), true);
                }
                finally {
                    this.__settingRawTerm = false;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "hasEditTermsCapabilities", {
            get: function () {
                return this._hasEditTermsCapabilities;
            },
            set: function (value) {
                this._hasEditTermsCapabilities = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "hasEditTermContentCapabilities", {
            get: function () {
                return this._hasEditTermContentCapabilities;
            },
            set: function (value) {
                this._hasEditTermContentCapabilities = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "hasUnlockOtherUserTermsCapability", {
            get: function () {
                return this._hasUnlockOtherUserTermsCapability;
            },
            set: function (value) {
                this._hasUnlockOtherUserTermsCapability = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "isEditButtonEnabled", {
            get: function () {
                return this._isEditButtonEnabled;
            },
            set: function (value) {
                this._isEditButtonEnabled = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "isEditButtonVisible", {
            get: function () {
                return this._isEditButtonVisible;
            },
            set: function (value) {
                this._isEditButtonVisible = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "currentUser", {
            get: function () {
                return this._currentUser;
            },
            set: function (value) {
                this._currentUser = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "hasNotifyContactsCapability", {
            get: function () {
                return this._hasNotifyContactsCapability;
            },
            set: function (value) {
                this._hasNotifyContactsCapability = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "termsViewMode", {
            get: function () {
                return this._termsViewMode;
            },
            set: function (value) {
                this._termsViewMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "selectedSnapshot", {
            get: function () {
                return this._selectedSnapshot;
            },
            set: function (value) {
                this._selectedSnapshot = value;
            },
            enumerable: true,
            configurable: true
        });
        EditTermPMController.prototype.onRawTermEditModeChanged = function (newValue, oldValue) {
            var _this = this;
            if (!this.rawTerm) {
                return;
            }
            if ((newValue && !oldValue) || (newValue && this.rawTerm.isEditMode && this.rawTerm.lockedBy == null)) {
                this.rawTerm.updateIsBusy(true, BusyKeys.LOCK_TERM);
                this.getMasterController().lockTerm(this.rawTerm, function (result) {
                    _this.syncTermLockStatus(result);
                    _this.rawTerm.updateIsBusy(false, BusyKeys.LOCK_TERM);
                }, function (error) {
                    if (error.errorCode == ErrorDictionary.TERM_ALREADY_LOCKED) {
                        _this.rawTerm.updateIsBusy(true, BusyKeys.GET_TERM_LOCKED_STATUS);
                        _this.rawTerm.updateIsBusy(false, BusyKeys.LOCK_TERM);
                        _this.getMasterController().getTermLockedStatus(_this.rawTerm, function (result) {
                            _this.rawTerm.updateIsBusy(false, BusyKeys.GET_TERM_LOCKED_STATUS);
                            if (result.lockedById != sas.hc.ui.core.util.UserInfo.instance.userid) {
                                _this.rawTerm.isEditMode = false;
                                _super.prototype.fireEvent.call(_this, EditTermPMController.ALREADY_LOCKED_EVENT, { lockedByName: result.lockedByName });
                            }
                        }, function (error) {
                            _this.rawTerm.isEditMode = false;
                            _this.handleError(error, BusyKeys.GET_TERM_LOCKED_STATUS);
                            _this.rawTerm.updateIsBusy(false, BusyKeys.GET_TERM_LOCKED_STATUS);
                        });
                    }
                    else {
                        _this.rawTerm.isEditMode = false;
                        _this.handleError(error, BusyKeys.LOCK_TERM);
                        _this.rawTerm.updateIsBusy(false, BusyKeys.LOCK_TERM);
                    }
                });
            }
        };
        Object.defineProperty(EditTermPMController.prototype, "viewEditButtonKeyView", {
            get: function () {
                return EditTermPMController.VIEWEDITBUTTON_KEY_VIEW;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "viewEditButtonKeyEdit", {
            get: function () {
                return EditTermPMController.VIEWEDITBUTTON_KEY_EDIT;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "publishAction", {
            get: function () {
                return this._publishAction;
            },
            set: function (value) {
                this._publishAction = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "submitWorkflowAction", {
            get: function () {
                return this._submitWorkflowAction;
            },
            set: function (value) {
                this._submitWorkflowAction = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "isRevision", {
            get: function () {
                return this._isRevision;
            },
            set: function (value) {
                this._isRevision = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "duplicateTermAction", {
            get: function () {
                return this._duplicateTermAction;
            },
            set: function (value) {
                this._duplicateTermAction = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "workflowActionsAction", {
            get: function () {
                return this._workflowActionsAction;
            },
            set: function (value) {
                this._workflowActionsAction = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "unlockTermAction", {
            get: function () {
                return this._unlockTermAction;
            },
            set: function (value) {
                this._unlockTermAction = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "renameTermAction", {
            get: function () {
                return this._renameTermAction;
            },
            set: function (value) {
                this._renameTermAction = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "notifyContactsTermAction", {
            get: function () {
                return this._notifyContactsTermAction;
            },
            set: function (value) {
                this._notifyContactsTermAction = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "savePdfTermAction", {
            get: function () {
                return this._savePdfTermAction;
            },
            set: function (value) {
                this._savePdfTermAction = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "refreshTermAction", {
            get: function () {
                return this._refreshTermAction;
            },
            set: function (value) {
                this._refreshTermAction = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EditTermPMController.prototype, "editTermActionsMenu", {
            get: function () {
                return this._editTermActionsMenu;
            },
            set: function (value) {
                this._editTermActionsMenu.replace(value);
            },
            enumerable: true,
            configurable: true
        });
        EditTermPMController.prototype.getMasterController = function () {
            return _super.prototype.getMasterController.call(this);
        };
        EditTermPMController.prototype.postSetContext = function (value) {
            if (this.getMasterController() != null) {
                this.initialize();
            }
            this.getView().setModel(this.asBindable(), "editTerm");
        };
        EditTermPMController.prototype.initialize = function () {
            var _this = this;
            this.unbind();
            this.hasEditTermsCapabilities = GrantedCapabilitiesCache.getInstance().hasCapability(GrantedCapabilitiesCache.EDIT_TERMS);
            this.hasEditTermContentCapabilities = GrantedCapabilitiesCache.getInstance().hasCapability(GrantedCapabilitiesCache.EDIT_TERM_CONTENTS);
            this.hasNotifyContactsCapability = GrantedCapabilitiesCache.getInstance().hasCapability(GrantedCapabilitiesCache.NOTIFY_CONTACTS);
            this.hasUnlockOtherUserTermsCapability = GrantedCapabilitiesCache.getInstance().hasCapability(GrantedCapabilitiesCache.UNLOCK_ANOTHER_USERS_TERMS);
            this.currentUser = sas.hc.ui.core.util.UserInfo.instance.userid;
            this.publishAction = new Action(this.resources.getText("terms.createEditPage.bar.button.publish.title"), $.proxy(this.saveTermAndPublish, this), sas.icons.HC.PUBLISH, this.resources.getText("terms.createEditPage.bar.button.publish.title"));
            this.submitWorkflowAction = new Action(this.resources.getText("terms.createEditPage.bar.button.submit.title"), $.proxy(this.submitWorkflow, this), sas.icons.HC.SENDTOWORKFLOW, null);
            this._masterControllerWatcher = BindingUtils.handlePropertiesChange(this.getMasterController(), ["termsViewMode", "selectedSnapshot", "activeDrilledInTerm"], function (property, newValue, oldValue) {
                if (property == "termsViewMode") {
                    _this.termsViewMode = newValue;
                }
                else if (property == "selectedSnapshot") {
                    _this.selectedSnapshot = newValue;
                }
                else if (property == "activeDrilledInTerm") {
                    if (TermSummary.EqualsById(_this.rawTerm, newValue) || (!_this.rawTerm && !!newValue)) {
                        _this.rawTerm = newValue;
                        _this.updateActions();
                    }
                }
            }, true);
            this._openTermsTermWatcher = BindingUtils.handleArrayItemPropertyChange(this.getMasterController().openTerms, "term", $.proxy(this.onOpenTermsTermChanged, this), true);
            this._openTermsRawTermWatcher = BindingUtils.handleArrayItemPropertyChange(this.getMasterController().openTerms, "rawTerm", $.proxy(this.onOpenTermsRawTermChanged, this), true);
            if (this.byId("editTermPage").getItem() && this.byId("editTermPage").getItem() instanceof ObjectManagerTermWrapper) {
                var termWrapper = (this.byId("editTermPage").getItem());
                this.rawTerm = termWrapper.term;
                if (termWrapper.term instanceof TermRevision) {
                    this.isRevision = true;
                }
            }
            this.updateActions();
            this._sasLineageUtils = SASLineageUtils.getInstance();
        };
        EditTermPMController.prototype.onOpenTermsTermChanged = function (item, property, newValue, oldValue) {
            if (newValue && !item.isInSelectedTermPanel && item.representsSameTerm(this.rawTerm) && newValue != this.term) {
                this.__currentlyHandlingOpenTermsTermChange = true;
                try {
                    this.term = newValue;
                    this.updateActions();
                }
                finally {
                    this.__currentlyHandlingOpenTermsTermChange = false;
                }
            }
        };
        EditTermPMController.prototype.onOpenTermsRawTermChanged = function (item, property, newValue, oldValue) {
            if (newValue && item.representsSameTerm(this.rawTerm) && newValue != this.rawTerm) {
                this.__currentlyHandlingOpenTermsRawTermChange = true;
                try {
                    this.rawTerm = newValue;
                    this.updateActions();
                }
                finally {
                    this.__currentlyHandlingOpenTermsRawTermChange = false;
                }
            }
        };
        EditTermPMController.prototype.cleanupBeforeTermClose = function (closeFunction) {
            var _this = this;
            var openTerm = this.getMasterController().getOpenTermForTerm(this.term);
            if (!openTerm) {
                if (closeFunction) {
                    closeFunction();
                }
                return;
            }
            if (openTerm.rawTerm && openTerm.rawTerm.isEditMode) {
                this.doUnlockTerm(openTerm.rawTerm, function () {
                    _this.getMasterController().removeOpenTermForTerm(openTerm.rawTerm);
                });
            }
            else {
                this.getMasterController().removeOpenTermForTerm(openTerm.rawTerm);
            }
            if (closeFunction) {
                closeFunction();
            }
        };
        EditTermPMController.prototype.doUnlockTerm = function (term, unlockSuccessHandler) {
            var _this = this;
            if (term === void 0) { term = null; }
            if (unlockSuccessHandler === void 0) { unlockSuccessHandler = null; }
            if (!term) {
                if (!this.rawTerm) {
                    return;
                }
                else {
                    term = this.rawTerm;
                }
            }
            this.getMasterController().getTermLockedStatus(term, function (result) {
                if (result.lockedById == _this.currentUser) {
                    _this.unlockTerm(term, unlockSuccessHandler);
                }
                else if (result.lockedById == null) {
                    _this.syncTermLockStatus(result);
                    term.isEditMode = false;
                    _this.updateActions();
                    if (unlockSuccessHandler) {
                        unlockSuccessHandler();
                    }
                }
            }, function (error) {
            });
        };
        EditTermPMController.prototype.syncTermLockStatus = function (termLockStatus) {
            if (this.term) {
                this.term.lockedBy = termLockStatus.lockedById;
                this.term.lockedByName = termLockStatus.lockedByName;
                this.term.lockedTimeStamp = termLockStatus.lockedDate;
            }
        };
        EditTermPMController.prototype.unlockTerm = function (term, successHandler) {
            var _this = this;
            if (term === void 0) { term = null; }
            if (successHandler === void 0) { successHandler = null; }
            if (!term) {
                if (!this.rawTerm) {
                    return;
                }
                else {
                    term = this.rawTerm;
                }
            }
            term.updateIsBusy(true, BusyKeys.UNLOCK_TERM);
            this.getMasterController().unlockTerm(term, function (result) {
                if (_this.rawTerm && TermSummary.EqualsById(_this.rawTerm, term)) {
                    _this.term = _this.rawTerm.clone(_this.term);
                }
                term.isEditMode = false;
                _this.updateActions();
                term.updateIsBusy(false, BusyKeys.UNLOCK_TERM);
                if (successHandler) {
                    successHandler();
                }
            }, function (error) {
                term.handleError(error, BusyKeys.UNLOCK_TERM);
            });
        };
        EditTermPMController.prototype.refreshTerm = function (successHandler) {
            var _this = this;
            this.term.updateIsBusy(true, BusyKeys.GET_TERM);
            var isEditMode = this.rawTerm.isEditMode;
            this.getMasterController().getTerm(this.term.id, this.rawTerm, function (response) {
                _this.term.updateIsBusy(false, BusyKeys.GET_TERM);
                _this.rawTerm.isEditMode = isEditMode;
                _this.updateActions();
                if (_this.rawTerm.workflowInstanceID && !_this.rawTerm.isSpecificRevision) {
                    _this.getCurrentWorkflowTasks(_this.rawTerm, true);
                }
                if (successHandler) {
                    successHandler();
                }
            }, function (error) {
                _this.term.handleError(error, BusyKeys.GET_TERM);
            });
        };
        EditTermPMController.prototype.resetTerm = function () {
            if (this.rawTerm.isEditMode) {
                if (this.term.isDirty) {
                    this.term.isDirty = false;
                }
                this.doUnlockTerm();
            }
        };
        EditTermPMController.prototype.getCurrentWorkflowTasks = function (term, refreshCurrent) {
            var _this = this;
            if (refreshCurrent === void 0) { refreshCurrent = false; }
            if (term && (!term.workflowTask || refreshCurrent === true) && !this.selectedSnapshot) {
                this.getMasterController().getCurrentWorkflowTasks([term], function (response) {
                    _this.updateActions();
                }, function (error) {
                    term.handleError(error, null);
                });
            }
        };
        EditTermPMController.prototype.startWorkflow = function () {
            var _this = this;
            this.term.updateIsBusy(true, BusyKeys.START_WORKFLOW);
            this.getMasterController().startWorkflow(true, [this.rawTerm], this.rawTerm.hasPublished ? WorkflowType.EDIT : WorkflowType.CREATE, $.proxy(this.onSubmitWorkflowSuccess, this), function (error) {
                _this.term.handleError(error, BusyKeys.START_WORKFLOW);
            });
        };
        EditTermPMController.prototype.submitWorkflow = function () {
            var _this = this;
            if (this.term.isDirty) {
                this.saveTermAsDraft(function () {
                    _this.doUnlockTerm(_this.rawTerm, $.proxy(_this.startWorkflow, _this));
                });
            }
            else {
                var response = this.validateTermDraft();
                if (response.isValid) {
                    this.doUnlockTerm(this.rawTerm, $.proxy(this.startWorkflow, this));
                }
            }
        };
        EditTermPMController.prototype.onSubmitWorkflowSuccess = function () {
            this.term = this.rawTerm.clone(this.term);
            this.updateActions();
            this.term.updateIsBusy(false, BusyKeys.START_WORKFLOW);
        };
        EditTermPMController.prototype.saveTermAsDraft = function (onSuccess, onError) {
            var _this = this;
            this.term.updateIsBusy(true, BusyKeys.SAVE_TERM_AS_DRAFT);
            var response = this.validateTermDraft();
            if (response.isValid) {
                this.term.isDirty = false;
                this.getMasterController().saveTermAsDraft(this.term, function (result) {
                    _this.term.updateIsBusy(false, BusyKeys.SAVE_TERM_AS_DRAFT);
                    _this.doUnlockTerm(_this.rawTerm, function () {
                        if (onSuccess) {
                            onSuccess();
                        }
                    });
                }, function (error) {
                    if (error.errorCode != CommonSharedProperties.ERROR_CODE_CANCELLED) {
                        if (error.errorCode == ErrorDictionary.NO_ROWS_UPDATED) {
                            _this.term.updateIsBusy(false, BusyKeys.SAVE_TERM_AS_DRAFT);
                            _this.term.isDirty = false;
                            MessageDialog.information({
                                text: _this.resources.getText("info.cant.save.unchanged.draft.fmt.msg", [_this.rawTerm.name])
                            });
                        }
                        else {
                            _this.term.isDirty = true;
                            _this.term.handleError(error, BusyKeys.SAVE_TERM_AS_DRAFT);
                        }
                        if (onError) {
                            onError();
                        }
                    }
                });
            }
            else {
                if (onError) {
                    onError();
                }
                this.term.updateIsBusy(false, BusyKeys.SAVE_TERM_AS_DRAFT);
            }
        };
        EditTermPMController.prototype.saveTermAndPublish = function () {
            var _this = this;
            this.term.updateIsBusy(true, BusyKeys.SAVE_TERM_AND_PUBLISH);
            var response = this.validateTermDraft();
            if (response.isValid) {
                if (this.rawTerm.isEditMode && this.term.isDirty) {
                    this.term.isDirty = false;
                    this.getMasterController().saveTermAndPublish(this.term, $.proxy(this.onSavePublishSuccessHandler, this), $.proxy(this.onSavePublishErrorHandler, this, true));
                }
                else {
                    this.getMasterController().publishTerms([this.term.id], function (responseMap) {
                        var result = responseMap[_this.term.id];
                        if (result && result instanceof ErrorResponse) {
                            _this.onSavePublishErrorHandler(false, result);
                        }
                        else if (result && result instanceof Term) {
                            _this.getMasterController().updateReferencesToTerm(result);
                            _this.onSavePublishSuccessHandler(result);
                        }
                        else {
                            _this.term.updateIsBusy(false, BusyKeys.SAVE_TERM_AND_PUBLISH);
                        }
                    }, $.proxy(this.onSavePublishErrorHandler, this, false));
                }
            }
            else {
                this.term.updateIsBusy(false, BusyKeys.SAVE_TERM_AND_PUBLISH);
            }
        };
        EditTermPMController.prototype.onSavePublishSuccessHandler = function (result) {
            this.term.updateIsBusy(false, BusyKeys.SAVE_TERM_AND_PUBLISH);
            this.updateActions();
            this.rawTerm.isEditMode = false;
        };
        EditTermPMController.prototype.onSavePublishErrorHandler = function (wasDirty, error) {
            this.term.isDirty = wasDirty;
            if (error.errorCode == CommonSharedProperties.ERROR_CODE_CANCELLED) {
                this.term.updateIsBusy(false, BusyKeys.SAVE_TERM_AND_PUBLISH);
                return;
            }
            if (error.errorCode == ErrorDictionary.NOT_LOCKED_BY_ACCOUNT) {
                error.message = this.resources.getText("error.cant.publish.locked.term.fmt.msg", [this.rawTerm.name]);
            }
            else if (error.errorCode == ErrorDictionary.PARENT_TERM_NOT_PUBLISHED) {
                error.message = this.resources.getText("error.cant.publish.draft.parent.fmt.msg", [this.rawTerm.name]);
            }
            else if (error.errorCode == ErrorDictionary.NO_ROWS_UPDATED) {
                this.term.updateIsBusy(false, BusyKeys.SAVE_TERM_AND_PUBLISH);
                this.term.isDirty = false;
                MessageDialog.information({
                    text: this.resources.getText("info.cant.publish.unchanged.term.fmt.msg", [this.rawTerm.name])
                });
                return;
            }
            this.term.handleError(error, BusyKeys.SAVE_TERM_AND_PUBLISH);
        };
        EditTermPMController.prototype.updateActions = function () {
            this.duplicateTermAction.isVisible = this.hasEditTermsCapabilities;
            this.submitWorkflowAction.isVisible = this.hasEditTermsCapabilities && BusinessDataUtils.showWorkflowSubmit(this.term, this.currentUser);
            this.submitWorkflowAction.isEnabled = BusinessDataUtils.enableWorkflowSubmit(this.term, this.currentUser);
            this.unlockTermAction.isVisible = this.hasEditTermContentCapabilities || this.hasUnlockOtherUserTermsCapability;
            this.unlockTermAction.isEnabled = !!this.rawTerm && !this.rawTerm.isEditMode && !!this.term && !!this.term.lockedBy && ((this.term.lockedBy === this.currentUser) || this.hasUnlockOtherUserTermsCapability);
            this.renameTermAction.isVisible = this.hasEditTermsCapabilities;
            this.renameTermAction.isEnabled = this.hasEditTermsCapabilities && BusinessDataUtils.enableRenameTerm(this.term);
            this.notifyContactsTermAction.isVisible = this.hasNotifyContactsCapability;
            this.savePdfTermAction.isEnabled = !!this.rawTerm && !this.rawTerm.isEditMode;
            this.publishAction.isVisible = !BusinessDataUtils.isWorkflowControlledTerm(this.term) && this.hasEditTermsCapabilities;
            this.publishAction.isEnabled = BusinessDataUtils.enablePublishTerm(this.term, this.currentUser);
            this.isEditButtonEnabled = !!this.rawTerm && this.hasEditTermContentCapabilities && BusinessDataUtils.enableEditTerm(this.rawTerm, this.currentUser);
            this.isEditButtonVisible = this.isEditButtonEnabled || (!!this.rawTerm && !!this.rawTerm.workflowTask && this.rawTerm.workflowTask.claimable && !BusinessDataUtils.isDeleteWorkflowActive(this.rawTerm));
            this.updateWorkflowActions();
        };
        EditTermPMController.prototype.updateWorkflowActions = function () {
            this.workflowActionsAction.subActions.splice(0, this.workflowActionsAction.subActions.length);
            var claimVisibleForActiveTerm = false;
            var unclaimVisibleForActiveTerm = false;
            if (this.rawTerm) {
                if (this.rawTerm.workflowTask) {
                    this.rawTerm.workflowTask.claimAction.isEnabled = this.rawTerm.workflowTask.claimable;
                    this.rawTerm.workflowTask.unclaimAction.isEnabled = this.rawTerm.workflowTask.isActualOwner;
                    BusinessDataUtils.calculateWorkflowPanelVisibility(this.rawTerm.workflowTask);
                }
                this.submitWorkflowAction.isVisible = this.hasEditTermContentCapabilities && BusinessDataUtils.showWorkflowSubmit(this.rawTerm, this.currentUser);
                if (this.rawTerm.workflowTask) {
                    claimVisibleForActiveTerm = this.rawTerm.workflowTask.claimAction.isVisible;
                    unclaimVisibleForActiveTerm = this.rawTerm.workflowTask.unclaimAction.isVisible;
                    this.workflowActionsAction.subActions.push(this.rawTerm.workflowTask.claimAction);
                    this.workflowActionsAction.subActions.push(this.rawTerm.workflowTask.unclaimAction);
                }
                if (this.submitWorkflowAction.isVisible) {
                    this.workflowActionsAction.subActions.push(this.submitWorkflowAction);
                }
            }
            else {
                this.submitWorkflowAction.isVisible = false;
            }
            this.workflowActionsAction.isEnabled = claimVisibleForActiveTerm || unclaimVisibleForActiveTerm || this.submitWorkflowAction.isVisible;
            if (this.workflowActionsAction.isEnabled && this.rawTerm.workflowTask) {
                var firstAction = true;
                for (var _i = 0, _a = this.rawTerm.workflowTask.workflowTransitionActions; _i < _a.length; _i++) {
                    var action = _a[_i];
                    if (firstAction) {
                        action.startsSection = true;
                        firstAction = false;
                    }
                    this.workflowActionsAction.subActions.push(action);
                }
            }
        };
        EditTermPMController.prototype.validateTermDraft = function () {
            var _this = this;
            var validationResponse = new ValidationResponse(true, "");
            if (this.term) {
                var attributes = this.term.attributes;
                var typeAttributes_1 = this.term.termType.attributes;
                if (!ArrayUtils.isEmpty(attributes) && !ArrayUtils.isEmpty(typeAttributes_1)) {
                    attributes.forEach(function (attr) {
                        var items = CollectionUtil.findItemsByField(typeAttributes_1, "label", attr.label);
                        if (items && items.length > 0) {
                            var typeAttribute = items[0];
                            if (validationResponse.isValid && typeAttribute.isRequired && StringUtils.isEmpty(attr.value)) {
                                validationResponse.isValid = false;
                                validationResponse.message = _this.resources.getText("error.missing.attribute.value.fmt.msg", [attr.label]);
                            }
                        }
                        else {
                            validationResponse.isValid = false;
                            validationResponse.message = _this.resources.getText("error.termtype.not.found.message");
                        }
                    });
                }
                if (validationResponse.isValid) {
                    var customAttributes = this.term.customAttributes;
                    var length_1 = customAttributes.length;
                    for (var i = 0; i < length_1; i++) {
                        if (customAttributes[i].isRequired && StringUtils.isEmpty(customAttributes[i].value)) {
                            validationResponse.isValid = false;
                            validationResponse.message = this.resources.getText("error.missing.attribute.value.fmt.msg", [customAttributes[i].label]);
                            break;
                        }
                    }
                }
            }
            if (!validationResponse.isValid) {
                MessageDialog.error({
                    text: validationResponse.message
                });
            }
            return validationResponse;
        };
        EditTermPMController.prototype.renameTerm = function (newTermName, successHandler) {
            var _this = this;
            this.getMasterController().renameTerm(this.rawTerm, newTermName, function () {
                _this.term.name = _this.rawTerm.name;
                if (successHandler) {
                    successHandler();
                }
            });
        };
        EditTermPMController.prototype.duplicateTerm = function (term, versionLabel, successHandler) {
            var _this = this;
            var response = this.validateTermDraft();
            if (response.isValid) {
                var hasUnsavedChanges = (this.rawTerm.isEditMode && this.term.isDirty);
                var originalTerm_1 = this.rawTerm;
                if (hasUnsavedChanges) {
                    var clonedTerm = Term.createFromSummary(this.term, this.term);
                    clonedTerm.name = term.name;
                    clonedTerm.parentId = term.parentId;
                    this.getMasterController().duplicateAndUpdateTerm(clonedTerm, versionLabel, function (duplicatedTerm) {
                        successHandler(duplicatedTerm);
                        _this.term.isDirty = false;
                        _this.rawTerm.isEditMode = false;
                        duplicatedTerm.isEditMode = true;
                        _this.setDrilledInTerm(duplicatedTerm);
                        _this.getMasterController().termToClose = originalTerm_1;
                    }, function (error) {
                        _this.handleError(error, null);
                    });
                }
                else {
                    this.getMasterController().duplicateTerm(term, versionLabel, function (duplicatedTerm) {
                        successHandler(duplicatedTerm);
                        _this.rawTerm.isEditMode = false;
                        duplicatedTerm.isEditMode = true;
                        _this.setDrilledInTerm(duplicatedTerm);
                        _this.getMasterController().termToClose = originalTerm_1;
                    }, function (error) {
                        _this.handleError(error, null);
                    });
                }
            }
        };
        EditTermPMController.prototype.termRefresh = function () {
            this.refreshTerm(null);
        };
        EditTermPMController.prototype.setDrilledInTerm = function (term) {
            this.getMasterController().activeDrilledInTerm = term;
        };
        EditTermPMController.prototype.getDrilledInTerm = function () {
            return this.getMasterController().activeDrilledInTerm;
        };
        EditTermPMController.prototype.unbind = function () {
            BindingUtils.unbind(this._openTermsTermWatcher);
            BindingUtils.unbind(this._openTermsRawTermWatcher);
            BindingUtils.unbind(this._masterControllerWatcher);
            BindingUtils.unbind(this._dirtyWatcher);
            BindingUtils.unbind(this._workflowTaskWatcher);
            BindingUtils.unbind(this._rawTermEditModeWatcher);
        };
        EditTermPMController.prototype.onViewLineage = function () {
            if (this.term) {
                this._sasLineageUtils.onViewLineage(this.term);
            }
        };
        EditTermPMController.prototype.mayEditTermWithErrorDialog = function () {
            return BusinessDataUtils.mayEditTermWithErrorDialog(this.resources, this.rawTerm, this.currentUser);
        };
        EditTermPMController.prototype.mayRenameTermWithErrorDialog = function () {
            return BusinessDataUtils.mayRenameTermWithErrorDialog(this.resources, this.rawTerm, this.currentUser);
        };
        EditTermPMController.prototype.destroy = function () {
            _super.prototype.destroy.call(this);
            this.unbind();
        };
        EditTermPMController.VIEWEDITBUTTON_KEY_VIEW = "view";
        EditTermPMController.VIEWEDITBUTTON_KEY_EDIT = "edit";
        EditTermPMController.ALREADY_LOCKED_EVENT = "locked";
        return EditTermPMController;
    }(BusinessDataPMControllerBase));
    return EditTermPMController;
});
